# GM Info Plugin

This unofficial TaleSpire plugin for adding text to minis and converted-props which only the GM can see.
Can be used on player visible props like chests to provide GM only information about the player visible properly
or on props that are hidden to provide the GM with notes (visible all the time).

## Change Log
```
3.0.0: Streamlined for performance
2.3.0: Added manual re-apply
2.3.0: Streamlined processing
2.2.0: Optimized Lookup for GM States Text
2.1.0: Fix for Cyberpunk update
2.0.0: Fix for BR HF Integration update
1.0.0: Initial release
```
## Install

Install using R2ModMan or similar.

## Usage

Press the shortcut key to activate the GM Info or use the radial menu to select GM Tools and then Info.
Enter the text to be shown at the prompt. To create multiple lines of text, use commas to seperate the each line.

Default: ``LCTRL``+``G``

The Remove option on the prompt can be use to remove GM info.

To re-apply GM Info if it does not get applied automatically after board load, use the re-apply shortcut.
Do to the way that the plugin now handles board loads, this should not be necessary but it is there just in case.

Default: ``RCTRL``+``G``

### Performance Optimization

The plugin only performs visual updates when necessary. While idle, the update loop does nothing but check for
the keyboard triggers and for mouse movement.

When GM Info is added to an asset it is always fully refreshed.

When the GM/Player Mode changes, the visibility of all assets is updated.

When the mouse is dragged or when the keyboard is used, the rotation of assets is updated based on the update
setting set in the configuration for the plugin. These settings are follows:

None = Text Blocks rotation (to face the screen) is not done.
Selected = Text Blocks rotation (to face the screen) is done to the currently selected mini only.
All = Text Blocks rotation (to face the screen) is done to all mini that have Text Blocks.

This setting can be further used to control performane. With on-demand updates only this plugin should run
fairly smooth on most device but this configuration can be used to tweak performance. If you have a high
performance device then set this option to "all". This will keep all Text Block rotated towards the screen
at all times. If you have a medium performance device, try the "selected" option. This will lower the CPU
requirement but at least keep the selected mini's Text Block facing the screen. If you have a low performance
device then try the "none" setting. This will not rotate Text Block to face the screen but will use the least
amount of CPU.

### Appearance

The size and offset of the text can be configured in the configuration. If you have a smaller or larger screen
the font size can be adjusted but then the offset per line will need to also be adjusted in order to make the
text appear correctly. To properly calibrate these settings, do the following:

1. Add a single line of text and see that it shows up just above the mini.
2. Change the text to 5 or more lines and see if the the bottom of the text still shows up just above the mini.

If the text increases the gap between the mini and the text when more lines are added the per line offset setting
needs to be made smaller. If the lines of go into the mini, the per line offset needs to be increased.

### Typical Scenario 1: Use With Player Visible Items

In this scenario the GM has a player visible prop like a chest and want to note down the contents of the chest.
The GM can add a GM Info note to the chest which will be visible to the GM only but not to the players.

### Typical Scenario 2: Use With Player Invisible Items

In this sceanrio the GM wants to leave some notes for himself but they are not assocaited with any particular
visible prop. In such a case the GM can add a prop or mini, and a GM Info note to the prop or mini and then
hide it. In such a case the players will not see either the prop or mini used for the note nor the note itself.
Please note that in this scenario the note will be visible to the GM at all times.
  
